#region Copyright Syncfusion Inc. 2001 - 2014
// Copyright Syncfusion Inc. 2001 - 2014. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using Syncfusion.UI.Xaml.Grid;
using Syncfusion.UI.Xaml.Grid.Cells;
using Syncfusion.UI.Xaml.ScrollAxis;
using Syncfusion.Windows.Shared;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace TwoLevelGridRowSelection
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window 
    {
        public MainWindow()
        {
            InitializeComponent();
            this.sfDataGrid.CellRenderers.Remove("CheckBox");
            this.sfDataGrid.CellRenderers.Add("CheckBox", new CheckBoxSelection());
            this.sfDataGrid.SelectionController = new RowSelectionController(this.sfDataGrid);
        }
   
    }

    public static class CheckBoxHelper
    {
        public static bool IsChecked { get; set; }
        public static bool Value { get; set; }
    }

    public class CheckBoxSelection:GridCellCheckBoxRenderer
    {
        public CheckBoxSelection():base()
        { }
        protected override void OnWireEditUIElement(CheckBox uiElement)
        {
            base.OnWireEditUIElement(uiElement);
            uiElement.GotFocus += uiElement_GotFocus;
            uiElement.LostFocus += uiElement_LostFocus;
        }

        void uiElement_LostFocus(object sender, RoutedEventArgs e)
        {
            CheckBoxHelper.IsChecked = false;
        }

        void uiElement_GotFocus(object sender, RoutedEventArgs e)
        {
            CheckBoxHelper.IsChecked = true;
            CheckBoxHelper.Value = !(bool)((CheckBox)e.OriginalSource).IsChecked;
        }
    }

    public class RowSelectionController:GridSelectionController
    {
        public RowSelectionController(SfDataGrid dataGrid):base(dataGrid)
        { }

        protected override void ProcessPointerReleased(MouseButtonEventArgs args, RowColumnIndex rowColumnIndex)
        {
            if (!CheckBoxHelper.IsChecked || rowColumnIndex.ColumnIndex !=  1)
                return;
            base.ProcessPointerReleased(args, rowColumnIndex);
        }
    }
}
