#region Copyright Syncfusion Inc. 2001 - 2014
// Copyright Syncfusion Inc. 2001 - 2014. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Data.SqlServerCe;
using System.Text.RegularExpressions;
using System.Windows.Media;
using System.Windows;
using System.Windows.Media.Imaging;
using System.Collections.ObjectModel;
using TwoLevelGridRowSelection.DataModel;
using Syncfusion.UI.Xaml.Grid;
namespace TwoLevelGridRowSelection
{
    public class ViewModel 
    {
        
        private ObservableCollection<OrderInfo> _orderList = new ObservableCollection<OrderInfo>();

        /// <summary>
        /// Gets or sets the order list.
        /// </summary>
        /// <value>The order list.</value>
        public ObservableCollection<OrderInfo> OrderList
        {
            get
            {
                return _orderList;
            }
            set
            {
                _orderList = value;
                //RaisePropertyChanged("OrderList");
            }
        }        

       
        /// <summary>
        /// Initializes a new instance of the <see cref="ViewModel"/> class.
        /// </summary>
        public ViewModel()
        {
            GetOrderDetails_ObservableCollection();
           
        }

        public void GetOrderDetails_ObservableCollection()
        {
            int i = 0;
            int j = 1;
            Northwind north = new Northwind(string.Format(@"Data Source= {0}", "Northwind.sdf"));

            foreach (OrderDetails orderDet in north.OrderDetails.Take(50))
            {
                OrderInfo orderInfo = new OrderInfo();

                orderInfo.OrderID = orderDet.OrderID;
                orderInfo.CustomerID = orderDet.Orders.CustomerID;
                orderInfo.ProductName = orderDet.Products.ProductName;
                orderInfo.UnitPrice = (double)orderDet.UnitPrice;
                orderInfo.Quantity = orderDet.Quantity;
                orderInfo.Discount = Math.Round(orderDet.Discount, 2);
                orderInfo.Freight = (double)orderDet.Orders.Freight;
                orderInfo.OrderDate = (DateTime)orderDet.Orders.OrderDate;
                orderInfo.ShippedDate = (DateTime)orderDet.Orders.ShippedDate;
                orderInfo.ShipPostalCode = orderDet.Orders.ShipPostalCode;
                orderInfo.ShipAddress = orderDet.Orders.ShipAddress;
                orderInfo.IsClosed = i % 2 == 0 ? true : false;
                orderInfo.DeliveryDelay = orderInfo.ShippedDate - orderInfo.OrderDate;
                orderInfo.HyperLinkShipAddress = orderDet.Orders.ShipAddress;
                orderInfo.Rating = i % 10;
              
                if (j % 3 == 0)
                {
                    orderInfo.ImageLink = "US.jpg";
                    orderInfo.ContactNumber = "878782";
                }
                else if (j % 2 == 0)
                {
                    orderInfo.ImageLink = "UK.jpg";
                    orderInfo.ContactNumber = "989894";
                }
                else
                {
                    orderInfo.ImageLink = "Japan.jpg";
                    orderInfo.ContactNumber = "838381";
                }
                j++;
                                                
               
                _orderList.Add(orderInfo);
                i++;
            }
        }

        
       
    }
}
